<?php

if (!defined('_PS_VERSION_'))
	exit;

class Calabuigcombinacionbarata extends Module
{
	protected $_html = '';
	 
	public function __construct()
	{
		$this->name = 'calabuigcombinacionbarata';
		$this->tab = 'front_office_features';
		$this->version = '1.2';
		$this->author = 'David Calabuig';
		$this->bootstrap = true;
		$this->need_instance = 0;
		parent::__construct();
		$this->displayName = $this->l('Combinacion más barata');
		$this->description = $this->l('Establecer la combinación más barata como la combinación por defecto');
		$this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
	}
	
	public function install()
	{
		return parent::install()			
		&& $this->registerHook('updateproduct');
	}
	
	public function uninstall()
	{
		return parent::uninstall()		
		&& $this->unregisterHook('updateproduct');
	}		
	
	public function hookUpdateProduct($params)
	{			
		$this->setDefaultCombination((int)$params['product']->id);
	}	
	
	public function getContent()
	{	
		$update = false;
		
		if(Tools::getValue('actualizarcombinacion'))
			$update = $this->actualizarCombinacionDefecto();
		
		$this->_html .= $this->renderForm($update);
        return $this->_html;
	}
	
	public function actualizarCombinacionDefecto()
	{
		$products = Db::getInstance()->executeS('SELECT id_product FROM '._DB_PREFIX_.'product');
			
			foreach ($products as $prod)			
				$this->setDefaultCombination($prod['id_product']);			
                	
		return true;
	}
	
	public function setDefaultCombination($id_prod)
	{
		$product = new Product($id_prod);			
		$combinations = $product->getAttributeCombinations((int)Configuration::get('PS_LANG_DEFAULT'));				
		$price = 9999999999;
		$id_product_attribute = 0;
		
		if(count($combinations) > 0)
			foreach ($combinations as $combination){
				if($combination['price'] < $price)
				{
					$price = $combination['price'];
					$id_product_attribute = $combination['id_product_attribute'];
				}
			}

		if($id_product_attribute != 0)
		{
			$product->deleteDefaultAttributes();
			$product->setDefaultAttribute((int)$id_product_attribute);
		}
	}
	
	public function renderForm($update)
	{
		if($update)
			$this->_html .= '<div class="bootstrap">
								<div class="module_confirmation conf confirm alert alert-success">
									<button data-dismiss="alert" class="close" type="button">×</button>
									Combinaciones actualizadas
								</div>
							</div>';
		
		$this->_html .= '<form enctype="multipart/form-data" method="post" action="index.php?controller=AdminModules&configure=calabuigcombinacionbarata&tab_module=front_office_features&module_name=calabuigcombinacionbarata&token='.Tools::getAdminTokenLite('AdminModules').'">
							<div id="fieldset_0" class="panel">												
								<div class="panel-heading">
									<i class="icon-link"></i> Actualizar combinacion por defecto
								</div>
												
								<div class="form-wrapper">											
									<div class="form-group">
										<p>Pulsa en el siguiente botón y se pondrá la combinación más barata como combinación predeterminada en todos los productos:</p>
										<input class="btn btn-default" type="submit" value="Actualizar combinaciones" name="actualizarcombinacion">
									</div>
								</div>
							</div>
							
							<div class="panel">
							    <div class="panel-heading"><i class="icon-cogs"></i> Contacto <a href="https://www.davidcalabuig.com/" target="_blank" style="">David Calabuig</a></div>
							    <p>Para cualquier consulta o mejora del módulo, puedes <a href="https://www.davidcalabuig.com/contactame/" target="_blank">contactar aquí</a></p>
							</div>
						</form>';
	}
}
